package com.loafle.totopia.member.controller;

import java.util.List;

import com.loafle.totopia.member.model.Member;

import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class MemberController {

    @GetMapping("/employees")
    public List<Member> all() {
      return repository.findAll();
    }
  
    @PostMapping("/employees")
    public Member newMember(@RequestBody Member newMember) {
      return repository.save(newMember);
    }
  
    // Single item
  
    @GetMapping("/employees/{id}")
    public Member one(@PathVariable Long id) {
  
      return repository.findById(id)
        .orElseThrow(() -> new MemberNotFoundException(id));
    }
  
    @PutMapping("/employees/{id}")
    public Member replaceMember(@RequestBody Member newMember, @PathVariable Long id) {
  
      return repository.findById(id)
        .map(employee -> {
          employee.setName(newMember.getName());
          employee.setRole(newMember.getRole());
          return repository.save(employee);
        })
        .orElseGet(() -> {
          newMember.setId(id);
          return repository.save(newMember);
        });
    }
  
    @DeleteMapping("/employees/{id}")
    public void deleteMember(@PathVariable Long id) {
      repository.deleteById(id);
    }
}